diff --git a/doc/geany.txt b/doc/geany.txt
index 2c05d03..52b7a64 100644
--- a/doc/geany.txt
+++ b/doc/geany.txt
@@ -262,7 +262,7 @@ You can start Geany in the following ways:
 
 * From the Desktop Environment menu:
 
-  Choose in your application menu of your used Desktop Environment:
+  Choose in the application menu of your used Desktop Environment:
   Development --> Geany.
 
 * From the command line:
@@ -441,7 +441,7 @@ using the appropriate command line option.
 Opening files from the command-line in a running instance
 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 
-Geany detects if there is an an instance of itself already running and opens files
+Geany detects if there is an instance of itself already running and opens files
 from the command-line in that instance. So, Geany can
 be used to view and edit files by opening them from other programs
 such as a file manager.
@@ -493,7 +493,7 @@ you can use the argument ``--login``.
     installed libvte correctly. Again note, Geany will run without this
     library.
 
-It could be, that the library is called something else than
+It could be that the library is called something other than
 ``libvte.so`` (e.g. on FreeBSD 6.0 it is called ``libvte.so.8``). If so
 please set a link to the correct file (as root)::
 
@@ -596,7 +596,7 @@ Geany tries to detect the encoding of a file while opening it, but
 auto-detecting the encoding of a file is not easy and sometimes an
 encoding might not be detected correctly. In this case you have to
 set the encoding of the file manually in order to display it
-correctly. You can this in the file open dialog by selecting an
+correctly. You can do this in the file open dialog by selecting an
 encoding in the drop down box or by reloading the file with the
 file menu item "Reload as". The auto-detection works well for most
 encodings but there are also some encodings where it is known that
@@ -626,7 +626,7 @@ There are different ways to set different encodings in Geany:
 * Specifying the encoding in the file itself
 
   As mentioned above, auto-detecting the encoding of a file may fail on
-  some encodings. If you know that Geany doesn't open a certain file,
+  some encodings. If you know that Geany doesn't open a certain file correctly,
   you can add the specification line, described in the next section,
   to the beginning of the file to force Geany to use a specific
   encoding when opening the file.
@@ -767,11 +767,11 @@ useful to insert text on multiple lines.
 Drag and drop of text
 ^^^^^^^^^^^^^^^^^^^^^
 
-If you drag selected text in the editor widget of Geany the text is
+If you drag selected text in the editor widget of Geany, the text is
 moved to the position where the mouse pointer is when releasing the
 mouse button. Holding Control when releasing the mouse button will
 copy the text instead. This behaviour was changed in Geany 0.11 -
-before the selected text was copied to the new position.
+before, the selected text was copied to the new position.
 
 
 Indentation
@@ -927,7 +927,7 @@ each filetype (see "context_action_cmd" in the section called
 specific command is used if available, otherwise the command
 specified in the preferences dialog is executed.
 
-The current word or selection can be referred with the wildcard "%s"
+The current word or selection can be referred to using the wildcard "%s"
 in the command, it will be replaced by the current word or
 selection before the command is executed.
 
@@ -1091,7 +1091,7 @@ to existing contructs of certain programming languages(like ``if``,
 
 **Template wildcards**
 
-Since Geany 0.15 you can also use most of the available templates wildcards
+Since Geany 0.15 you can also use most of the available template wildcards
 listed in `Template wildcards`_. All wildcards which are listed as
 `available in snippets` can be used. For instance to improve the above example::
 
@@ -1104,8 +1104,8 @@ preference ``developer``.
 
 **Word characters**
 
-You can change the way Geany recognizes the word to complete,
-that is how the start and end of a word is recognised when the
+You can change the way Geany recognizes the word to complete;
+that is, how the start and end of a word are recognised when the
 snippet completion is requested. The section "Special" may
 contain a key "wordchars" which lists all characters a string may contain
 to be recognized as a word for completion. Leave it commented to use
@@ -1177,7 +1177,7 @@ Search bar
 ``````````
 The quickest way to find some text is to use the search bar entry in
 the toolbar. This performs a case-insensitive search in the current
-document whilst you type. Pressing Enter will search again, and pressing
+document while you type. Pressing Enter will search again, and pressing
 Shift-Enter will search backwards.
 
 Find
@@ -1228,7 +1228,7 @@ Change font in search dialog text fields
 All search related dialogs use a Monospace for the text input fields to
 increase the readability of input text. This is useful when you are
 typing input such as regular expressions with spaces, periods and commas which
-might it hard to read with a proportional font.
+might be hard to read with a proportional font.
 
 If you want to change the font, you can do this easily
 by inserting the following style into your ``.gtkrc-2.0``
@@ -1623,7 +1623,7 @@ by the pipe character (``|``). A line looks like::
 | The first field is the tag name (usually a function name).
 | The second field is the type of the return value.
 | The third field is the argument list for this tag.
-| The fourth field is the description for this tag but
+| The fourth field is the description for this tag but is
   currently unused and should be left empty.
 
 Except for the first field (tag name), all other field can be left
@@ -1660,7 +1660,7 @@ Example for the wxD library for the D programming language::
 
 Generating C/C++ tag files
 **************************
-You may need to first setup the `C ignore.tags`_ file.
+You may need to first set up the `C ignore.tags`_ file.
 
 For C/C++ tag files gcc is required by default, so that header files
 can be preprocessed to include any other headers they depend upon. If
@@ -1706,7 +1706,7 @@ This will parse code like:
 ``gchar **utils_strv_new(const gchar *first, ...)
 G_GNUC_NULL_TERMINATED;``
 
-More detailed information about ignore tags usage from the Exuberant Ctags
+More detailed information about ignore tags usage, from the Exuberant Ctags
 manual page:
 
     Specifies a list of identifiers which are to be specially handled
@@ -1918,7 +1918,7 @@ Editor tabs
 ```````````
 
 Show editor tabs
-    Show a notebook tab for all documents so you can switch between them
+    Show a notebook tab for each document so you can switch between them
     using the mouse (instead of using the Documents window).
 
 Show close buttons
@@ -1956,7 +1956,7 @@ Message window
 Interface Toolbar preferences
 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 
-Affects the main toolbar underneath the menu bar.
+Affects the main toolbar immediately under the menu bar.
 
 .. image:: ./images/pref_dialog_interface_toolbar.png
 
@@ -2288,7 +2288,7 @@ Default encoding (existing files)
     Use this option when it's not possible for Geany to detect the exact encoding.
 
 Default end of line characters
-    The end of line characters to which should be used for new files.
+    The end of line characters which should be used for new files.
     On Windows systems, you generally want to use CR/LF which are the common
     characters to mark line breaks.
     On Unix-like systems, LF is default and CR is used on MAC systems.
@@ -2464,7 +2464,7 @@ Various preferences
 .. image:: ./images/pref_dialog_various.png
 
 Rarely used preferences, explained in the table below. A few of them require
-restart to take effect, and a few other will only affect newly opened or created
+restart to take effect, and a few others will only affect newly opened or created
 documents before restart.
 
 ================================  =========================================  ==========  ===========
@@ -2538,17 +2538,17 @@ send_selection_unsafe             By default, Geany strips any trailing        f
                                   If, for whatever reasons, you really want
                                   it to be executed directly, set this option
                                   to true.
-send_cmd_prefix                   String with which prefix the commands sent   Empty       immediately
-                                  to the shell.  This may be used to tell
-                                  some shells (BASH with ``HISTCONTROL`` set
-                                  to ``ignorespace``, ZSH with
+send_cmd_prefix                   String with which to prefix the commands     Empty       immediately
+                                  sent to the shell.  This may be used to
+                                  tell some shells (BASH with ``HISTCONTROL``
+                                  set to ``ignorespace``, ZSH with
                                   ``HIST_IGNORE_SPACE`` enabled, etc.) from
                                   putting these commands in their history by
                                   setting this to a space.  Note that leading
                                   spaces must be escaped using `\s` in the
                                   configuration file.
 **File related**
-use_atomic_file_saving            Defines the mode how Geany saves files to    false       immediately
+use_atomic_file_saving            Defines how Geany saves files to             false       immediately
                                   disk. If disabled, Geany directly writes
                                   the content of the document to disk. This
                                   might cause loss of data when there is
@@ -2566,7 +2566,7 @@ use_atomic_file_saving            Defines the mode how Geany saves files to    f
                                   The better approach would be to ensure your
                                   disk won't run out of free space.
 use_gio_unsafe_file_saving        Whether to use GIO as the unsafe file        true        immediately
-                                  saving backend. It is better on most
+                                  saving backend. It is better in most
                                   situations but is known not to work
                                   correctly on some complex setups.
 gio_unsafe_save_backup            Make a backup when using GIO unsafe file     false       immediately
@@ -2577,9 +2577,9 @@ extract_filetype_regex            Regex to extract filetype name from file     S
 **Search related**
 find_selection_type               See `Find selection`_.                       0           immediately
 **Build Menu related**
-number_ft_menu_items              The maximum number of menu items in the      2           on restart
+number_ft_menu_items              The maximum number of menu items in the      3           on restart
                                   filetype section of the Build menu.
-number_non_ft_menu_items          The maximum number of menu items in the      3           on restart
+number_non_ft_menu_items          The maximum number of menu items in the      4           on restart
                                   independent section of the Build menu.
 number_exec_menu_items            The maximum number of menu items in the      2           on restart
                                   execute section of the Build menu.
@@ -2597,7 +2597,7 @@ See also: `Virtual terminal emulator widget (VTE)`_.
 Terminal widget
 ```````````````
 
-Terminal font
+Font
     Select the font that will be used in the terminal emulation control.
 
 Foreground color
@@ -2636,8 +2636,8 @@ Follow path of the current file
 
 Execute programs in VTE
     Execute programs in the virtual terminal instead of using the external
-    terminal tool.  Note that if you run multiple execute commands at once
-    the output may become mixed together in the VTE.
+    terminal tool.  Note that if you run multiple execute commands
+    simultaneously, the output may become mixed together in the VTE.
 
 Don't use run script
     Don't use the simple run script which is usually used to display
@@ -2664,7 +2664,7 @@ the items defined in project's settings, instead of the defaults.
 See `Build Menu Configuration`_ for information on configuring the menu.
 
 The current project's settings are saved when it is closed, or when
-Geany is shutdown. When restarting Geany, the previously opened project
+Geany is shut down. When restarting Geany, the previously opened project
 file that was in use at the end of the last session will be reopened.
 
 The project menu items are detailed below.
@@ -2674,11 +2674,11 @@ New project
 ^^^^^^^^^^^
 
 To create a new project, fill in the *Name* field. By default this
-will setup a new project file ``~/projects/name.geany``. Usually it's
+will set up a new project file ``~/projects/name.geany``. Usually it's
 best to store all your project files in the same directory (they are
 independent of any source directory trees).
 
-The Base path text field is setup to use ``~/projects/name``. This
+The Base path text field is set up to use ``~/projects/name``. This
 can safely be set to any existing path -- it will not touch the file
 structure contained in it.
 
@@ -2690,7 +2690,7 @@ You can set an optional description for the project. Currently it's
 only used for a template wildcard - see `Template wildcards`_.
 
 The *Base path* field is used as the directory to run the Build menu commands.
-The specified path can be an absolute path or it is considered to be
+If the specified path is not an absolute path, it is considered to be
 relative to the project's file name.
 
 The *File patterns* field allows to specify a list of file patterns for the
@@ -2898,15 +2898,15 @@ Build menu configuration
 ^^^^^^^^^^^^^^^^^^^^^^^^
 
 The build menu has considerable flexibility and configurability, allowing
-both menu labels the commands they execute and the directory they execute
-in to be configured.
+menu labels, the commands they execute, and the directory in which they execute
+to be configured.
 
-For example, if you change one of the default make commands to run say 'waf'
+For example, if you change one of the default make commands to run, say, 'waf',
 you can also change the label to match.
 
 These settings are saved automatically when Geany is shut down.
 
-The build menu is divided into four groups of items each with different
+The build menu is divided into up to five groups of items each with different
 behaviors:
 
 * Filetype build commands - are configurable and depend on the filetype of the
@@ -2915,14 +2915,15 @@ behaviors:
 * Independent build commands - are configurable and mostly don't depend on the
   filetype of the current document; they also capture output in the
   compiler tab and parse it for errors.
-* Execute commands - are configurable and intended for executing your
+* Execute commands - are configurable and are intended for executing your
   program or other long running programs.  The output is not parsed for errors
   and is directed to the terminal command selected in preferences.
 * Fixed commands - these perform built-in actions:
 
   * Go to the next error.
   * Go to the previous error.
-  * Show the build menu commands dialog.
+
+* Show the build menu commands dialog.
 
 The maximum numbers of items in each of the configurable groups can be
 configured in the `Various preferences`_. Even though the maximum number of
@@ -2985,7 +2986,7 @@ The following notes on the table reference cells by coordinate as (group,source)
 * (Filetype, Project File) and (Filetype, Preferences) - preferences use a full
   filetype file so that users can configure all other filetype preferences
   as well.  Projects can only configure menu items per filetype.  Saving
-  in the project file means that there is only one file per project not
+  in the project file means that there is only one file per project, not
   a whole directory.
 
 * (Filetype-Independent, System Filetype) - although conceptually strange, defining
@@ -3000,11 +3001,11 @@ The following notes on the table reference cells by coordinate as (group,source)
 Build menu commands dialog
 ^^^^^^^^^^^^^^^^^^^^^^^^^^
 
-Most of the configuration of the build menu is done through the Build Menu
-Commands Dialog.  You edit the configuration sourced from preferences in the
-dialog opened from the Build->Build Menu Commands item and you edit the
+Most of the configuration of the build menu is done through the Set Build
+Commands dialog.  You edit the configuration sourced from preferences in the
+dialog opened from the Build->Set Build Commands item and you edit the
 configuration from the project in the build tab of the project preferences
-dialog.  Both use the same form shown below.
+dialog.  Both use the same dialog shown below.
 
 .. image:: ./images/build_menu_commands_dialog.png
 
@@ -3012,7 +3013,7 @@ The dialog is divided into three sections:
 
 * Filetype build commands (selected based on the current document's filetype).
 * Independent build commands (available regardless of filetype).
-* Filetype execute commands.
+* Execute commands.
 
 The filetype and independent sections also each contain a field for the regular
 expression used for parsing command output for error and warning messages.
@@ -3034,10 +3035,10 @@ configuration source you are editing then the command will be shown
 in the dialog but will be insensitive (greyed out).  This can't happen
 with the project source but can with the preferences source dialog.
 
-The clear buttons remove the definition from the configuration source you are editing.
+The reset buttons remove the definition from the configuration source you are editing.
 When you do this the command from the next lower priority source will be shown.
-To hide lower priority menu items without having anything show in the menu
-configure with a nothing in the label but at least one character in the command.
+To hide lower priority menu items without having anything show in the menu,
+configure a definition with an empty label and at least one character in the command.
 
 Substitutions in commands and working directories
 `````````````````````````````````````````````````
@@ -3052,11 +3053,11 @@ before the command is run.
 * %p - if a project is open, substituted by the base path from the project.
 
 .. note::
-   If the basepath set in the project preferences is not an absolute path , then it is
+   If the basepath set in the project preferences is not an absolute path, then it is
    taken as relative to the directory of the project file.  This allows a project file
    stored in the source tree to specify all commands and working directories relative
-   to the tree itself, so that the whole tree including the project file, can be moved
-   and even checked into and out of version control without having to re-configure the
+   to the tree itself, so that the whole tree, including the project file, can be moved
+   and even checked in to and out of version control without having to re-configure the
    build menu.
 
 Build menu keyboard shortcuts
@@ -3135,7 +3136,7 @@ will not show errors from the command itself, so you should make
 sure that it works before(e.g. by trying to execute it from the
 command line).
 
-A nicer example, which many prefer is::
+A nicer example, which many prefer, is::
 
     % a2ps -1 --medium=A4 -o - %f | xfprint4
 
@@ -3169,8 +3170,8 @@ The Plugin Manager dialog lets you choose which plugins
 should be loaded at startup. You can also load and unload plugins on the
 fly using this dialog. Once you click the checkbox for a specific plugin
 in the dialog, it is loaded or unloaded according to its previous state.
-By default, no plugins are loaded at startup until you select some.
-You can also configure some plugin specific options if the plugin
+By default, no plugins are loaded at startup until you select them.
+You can also configure plugin specific options if the plugin
 provides any.
 
 
@@ -3204,7 +3205,7 @@ Configurable keybindings
 
 For all actions listed below you can define your own keybindings. Open
 the Preferences dialog, select the desired action and click on
-change. In the resulting dialog you can press the key combination you
+Change. In the resulting dialog you can press the key combination you
 want to assign to the action and it will be saved when you press OK.
 You can define only one key combination for each action and each key
 combination can only be defined for one action.
@@ -3302,9 +3303,9 @@ Context Action                                            Executes a command and
                                                           argument. See the section called `Context
                                                           actions`_.
 
-Move cursor in snippet                                    Jumps to the next defined cursor positions in a
-                                                          completed snippets if multiple cursor positions
-                                                          where defined.
+Move cursor in snippet                                    Jumps to the next defined cursor position in a
+                                                          completed snippet if multiple cursor positions
+                                                          were defined.
 
 Word part completion            Tab                       When the autocompletion list is visible, complete
                                                           the currently selected item up to the next word
@@ -3329,10 +3330,10 @@ Copy                            Ctrl-C  (C)               Copy the current selec
 
 Paste                           Ctrl-V  (C)               Paste the clipboard text into the current document.
 
-Cut current line(s)             Ctrl-Shift-X              Cuts the current line (and any lines with a
+Cut current line(s)             Ctrl-Shift-X              Cut the current line (and any lines with a
                                                           selection) to the clipboard.
 
-Copy current line(s)            Ctrl-Shift-C              Copies the current line (and any lines with a
+Copy current line(s)            Ctrl-Shift-C              Copy the current line (and any lines with a
                                                           selection) to the clipboard.
 =============================== ========================= ==================================================
 
@@ -3665,8 +3666,8 @@ Project keybindings
 Action                          Default shortcut          Description
 =============================== ========================= ==================================================
 New                                                       Create a new project.
-Open                                                      Opens a project file.
-Properties                                                Shows project properties.
+Open                                                      Open a project file.
+Properties                                                Show project properties.
 Close                                                     Close the current project.
 =============================== ========================= ==================================================
 
@@ -3939,8 +3940,8 @@ You can omit fields to use the values from the style named ``"default"``.
 
 E.g. ``key=0xff0000;;true``
 
-This makes the key style have red foreground text, default background
-color text and bold emphasis.
+This makes the key style have red foreground text color, default background
+color and bold emphasis.
 
 Using a named style
 *******************
@@ -4101,7 +4102,7 @@ tag_parser
 .. _lexer_filetype:
 
 lexer_filetype
-    A filetype name to setup syntax highlighting from another filetype.
+    A filetype name to set up syntax highlighting from another filetype.
     This must not be recursive, i.e. it should be a filetype name that
     doesn't use the *lexer_filetype* key itself, e.g.::
 
@@ -4175,7 +4176,7 @@ error_regex
 
 **Build commands**
 
-If any build menu item settings have been configured in the Build Menu Commands
+If any build menu item settings have been configured in the Set Build Commands
 dialog or the Build tab of the project preferences dialog then these
 settings are stored in the [build-menu] section and override the settings in
 this section for that item.
@@ -4270,7 +4271,7 @@ For example::
     [named_styles]
     foo=my_red_color;my_blue_color;false;true
 
-This allows to define a color pallete by name so that to change a color
+This allows to define a color palette by name so that to change a color
 scheme-wide only involves changing the hex value in a single location.
 
 [styling] section
@@ -4306,8 +4307,8 @@ brace_bad
     *Example:* ``brace_bad=0x0000ff;0xFFFFFF;true;false``
 
 caret
-    The style for coloring the caret(the blinking cursor). Only first
-    and third argument is interpreted.
+    The style for coloring the caret(the blinking cursor). Only the first
+    and third arguments are interpreted.
     Set the third argument to true to change the caret into a block caret.
 
     *Example:* ``caret=0x000000;0x0;false;false``
@@ -4337,7 +4338,7 @@ indent_guide
 
 white_space
     The style for coloring the white space if it is shown. The first
-    both arguments define the foreground and background colors, the
+    two arguments define the foreground and background colors, the
     third argument sets whether to use the defined foreground color
     or to use the color defined by each filetype for the white space.
     The fourth argument defines whether to use the background color.
@@ -4397,7 +4398,7 @@ line_wrap_visuals
     * 2 -- Visual flag at begin of subline of a wrapped line. Subline is
       indented by at least 1 to make room for the flag.
 
-    Second argument: wether the visual flags to indicate a line is wrapped
+    Second argument: whether the visual flags to indicate a line is wrapped
     are drawn near the border or near the text. This is a bitmask of the values:
 
     * 0 -- Visual flags drawn near border
@@ -4428,7 +4429,7 @@ translucency
     (second argument). Values between 0 and 256 are accepted.
 
     Note for Windows 95, 98 and ME users:
-    keep this value at 256 to disable translucency otherwise Geany might crash.
+    keep this value at 256 to disable translucency; otherwise, Geany might crash.
 
     Only the first and second arguments are interpreted.
 
@@ -4444,7 +4445,7 @@ marker_line
     *Example:* ``marker_line=0x000000;0xffff00;false;false``
 
 marker_search
-    The style for a marked search results (when using "Mark" in Search dialogs).
+    The style for a marked search result (when using "Mark" in Search dialogs).
     The second argument sets the background color for the drawn rectangle.
 
     Only the second argument is interpreted.
@@ -4465,7 +4466,7 @@ marker_translucency
     (second argument). Values between 0 and 256 are accepted.
 
     Note for Windows 95, 98 and ME users:
-    keep this value at 256 to disable translucency otherwise Geany might crash.
+    keep this value at 256 to disable translucency; otherwise, Geany might crash.
 
     Only the first and second arguments are interpreted.
 
@@ -4515,7 +4516,7 @@ also `Configuration file paths`_.
 You should only list lines for filetype extensions that you want to
 override in the user configuration file and remove or comment out
 others. The patterns are listed after the ``=`` sign, using a
-semi-colon separated list of patterns which should be matched for
+semicolon separated list of patterns which should be matched for
 that filetype.
 
 For example, to override the filetype extensions for Make, the file
@@ -4608,7 +4609,7 @@ project file.
 
 For each filetype the entries for that filetype have the format defined in
 `[build-menu] section`_ but the key is prefixed by the name of the filetype
-as it appears in the ``filetypes`` entry, eg the entry for the label of
+as it appears in the ``filetypes`` entry, e.g. the entry for the label of
 filetype menu item 0 for the C filetype would be
 
   ``CFT_00_LB=Label``
@@ -4951,8 +4952,8 @@ the entity for the character at the current cursor position. You
 might also like to double click the chosen entity instead.
 
 
-Replace special chars by its entity
-^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+Replace special char by its entity
+^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 
 To help make a XML/HTML document valid the plugin supports
 replacement of special chars known by the plugin. Both bulk
@@ -4994,8 +4995,8 @@ Save Actions
 Instant Save
 ^^^^^^^^^^^^
 This plugin sets on every new file (*File->New* or *File->New (with template)*)
-a randomly chosen filename and set its filetype appropriate to the used template
-or when no template was used, to a configurable default filetype.
+a randomly chosen filename and sets its filetype appropriate to the used template
+or, when no template was used, to a configurable default filetype.
 This enables you to quickly compile, build and/or run the new file without the
 need to give it an explicit filename using the Save As dialog. This might be
 useful when you often create new files just for testing some code or something
@@ -5010,7 +5011,7 @@ saved. You can specify the directory where the backup copy is saved and
 you can configure the automatically added extension in the configure dialog
 in Geany's plugin manager.
 
-After the plugin was loaded in Geany's plugin manager, every file is
+After the plugin is loaded in Geany's plugin manager, every file is
 copied into the configured backup directory when the file is saved in Geany.
 
 
@@ -5020,7 +5021,7 @@ Contributing to this document
 
 This document (``geany.txt``) is written in `reStructuredText`__
 (or "reST"). The source file for it is located in Geany's ``doc``
-subdirectory.  If you intend on making changes, you should grab the
+subdirectory.  If you intend to make changes, you should grab the
 source right from Git to make sure you've got the newest version. After
 editing the file, to build the HTML document to see how your changes
 look, run "``make doc``" in the subdirectory ``doc`` of Geany's source
@@ -5036,7 +5037,7 @@ After you are happy with your changes, create a patch e.g. by using::
 
 or even better, by creating a Git-formatted patch which will keep authoring
 and description data, by first committing your changes (doing so in a fresh
-new branch is recommended for `matser` not to diverge from upstream) and then
+new branch is recommended for `master` not to diverge from upstream) and then
 using git format-patch::
 
     % git checkout -b my-documentation-changes # create a fresh branch
@@ -5076,7 +5077,7 @@ Keyboard commands
 
 Keyboard commands for Scintilla mostly follow common Windows and GTK+
 conventions. All move keys (arrows, page up/down, home and end)
-allows to extend or reduce the stream selection when holding the
+allow to extend or reduce the stream selection when holding the
 Shift key, and the rectangular selection when holding the
 appropriate keys (see `Column mode editing (rectangular selections)`_).
 